~^INDEX^                        Page                                Page

      Alter registers        ^ 11 ^         Immediate Commands     ^  6 ^     
      Arithmetic             ^ 31 ^         Interrupting code      ^ 15 ^
      Assembler              ^ 33 ^         Job control            ^ 30 ^
      Assembler listing      ^ 37 ^         Labels                 ^ 36 ^
      Break Points           ^ 14 ^         Load, Save & Device    ^ 16 ^     
      Commands from files    ^ 31 ^         Memory editor          ^ 28 ^
      Directives             ^ 37 ^         Miscellaneous          ^ 32 ^
      Disassembler/Dump      ^  8 ^         Move/fill              ^ 26 ^
      Dual screens           ^ 23 ^         Number notations       ^  4 ^     
      Dual windows           ^  9 ^         Printers               ^ 18 ^     
      Exception handling     ^  5 ^         QDOS labels            ^ 39 ^     
      Exec, Call             ^ 13 ^         Search/insert          ^ 25 ^
      Extended commands      ^  7 ^         Set display            ^ 29 ^
      Function keys          ^ 22 ^         Trace program          ^ 10 ^     
      Heap allocation        ^ 27 ^         Vector table           ^  5 ^~^Use of this manual^

This is the ASSEMBLER WORKBENCH 'electronic' instruction manual. It has
been designed to allow the user to find a page quickly and efficiently.

     The following options are available :-

               ^  ^      Display previous page
               ^  ^      Display next page
               ^ESC^      Quit/Close manual
               ^ F5 ^     Display index and select page
               ^SPACE^    Unfreeze screen
~^INTRODUCTION^

ASSEMBLER WORKBENCH is a complete machine code development package. It
consists of two main program modules :- an ^assembler^ and a ^monitor^.
The package uses about 30 Kbytes of memory when both programs are loaded.

The assembler can operate in a conventional ^two-pass^ mode or as a
^one-line^ assembler. The latter allows direct modification of machine
code using standard 68000 mnemonics. Making small changes to a program
already in memory is much faster than patching in hexadecimal or
re-assembling the whole of the program.

   The monitor provides features such as :

        . Interruption of executing program by pressing ESC
        . Versatile break points
        . ^Dual screens^ for graphics programs (not under PE)
        . Works with or without Pointer Enviroment
        . Compatible with all 680x0 supervisor stack formats
~^FEATURES^

 . Disassembler                   . Hex and ASCII dumps
 . Line or Two Pass Assembler     . On-line help
 . Trace code in RAM and ROM      . Trace QDOS traps option
 . Dual disassembly windows       . Dual dump windows
 . Full window memory editor      . Break and trace points
 . Set registers                  . Printer & file access
 . Search, Move, Fill, Insert     . Function key definer
 . Job and channel control        . Various screen layouts
 . ESC interrupts user code       . PE/SMSQ compatible
 . Minerva second screen          . Move display with CTRL F4
 . Multiple monitor jobs          . QDOS trap keys 'included'
 . Commands from file             . Local default devices
 . Link window output to file     . Multi-window display
 . Exception error trapping       . Traps #8-15 redefinable
~^Monitor^

^Number notations^

    By default, all numbers are hexadecimal. Decimal numbers can be
specified by preceding a number with an ^ & ^.

        e.g   10 = ^Sixteen^
             &10 = ^Ten^

    If a ^ ` ^ precedes a number, the number is relative to the base
address of the current job.

        e.g  `10  = base address + sixteen
             `&10 = base address + ten

    During a ^break^, an ^ = ^ is equivalent to the address of the break.
For example, if there is a break at 40000, then typing ^DASM = ^ will start
disassembly from address 40000.

    Some commands return a number. You can type ^ * ^ as a short form of
that number.

        e.g  If ^LOAd flp1_file^  returns ^Loaded at 45678 ^, then
                ^DASm * ^ is equivalent to ^DASm 45678 ^

^ N.B ^
    To maintain compatibility with other assemblers, the number notation
is different for the assembler. Numbers are, by default, decimal unless
preceded by a ^ $ ^ sign. See ^Assembler^ for more details.

^Arithmetic Operators^

  The operators ^ + ^ and ^ - ^ can be used on the command line, e.g
^ DASm 20000+&100-30+`2 ^.
~^Vector Table^

  Some vectors are used by the monitor and must not be re-directed. These
are the vectors for traps 5-7 and the TRACE vector. Other vectors can be
re-defined, but the same vector table ^(MT_TRAPV)^ must be used. The
^TABle^ command will print the address of the monitor's vector table.

^Exception Handling^

   Illegal instructions, division by zero, address and privilege errors
are trapped by the monitor but may be re-defined if desired.

   If a program generates an exception it will be interrupted.  The
instruction which has caused the exception is disassembled. A message
such as ^"Address Error at 00078009"^ will also be printed. Note that in
most cases this address will be correct but in some instances it may be
up to eight bytes more than expected - (this is a 68008 anomaly).
~^Commands^

   The monitor responds to two types of commands -- ^immediate^ and
^extended^. Immediate commands are those which are specified with a
function key or with a control key combination. These commands are
executed as soon as they are received (i.e without waiting for the
^ENTER^ key). On the other hand, extended commands are typed in on the
command line and are executed when the ^ENTER^ key is pressed.

^Immediate Commands^

   The five function keys F1-F5 are defined as follows :-

  ^ F1 ^   Freezes / unfreezes screen output. F1 can be used at any time.
         When the screen is frozen, the ^SPACE^ bar enables you to
         inspect the output one line at a time.
  ^ F2 ^   Enables / disables the display of a designated memory area
         after a trace or a break (See ^DISplay^).
  ^ F3 ^   Selects character/hex mode while editing memory. (See ^EDIt^)
  ^ F4 ^   Resets any dual window. (See ^WINdow^)
  ^ F5 ^   Redraws all windows.

  ^SHIFT F1-F5^ can be user-defined. (See ^DEFine^)
  ^CTRL D^ sets up dual disassembler windows.
  ^CTRL H^ sets up dual hex dump windows.
  ^CTRL S^ swaps the screen being displayed, if dual screens are enabled.

  ^CTRL F4^ allows you to move the job display. (only in the PE)
  ^ESC^     will abort a partially entered line.
  ^ALT ^   moves the cursor to the start of a line.
  ^ALT ^   moves the cursor to the end of a line.
~^Extended Commands^

   ^No distinction^ is made between upper and lower case characters, except
when searching for strings. There are 53 extended commands which are
recognised by their ^first three^ characters.

   e.g   ^SEARCH 'string' 0 ^ can be abbreviated to ^SEA 'string' 0 ^

^Parameters^

   Parameters are separated by a ^SPACE^. If a command is recognised as
having bad parameters, the correct syntax will be printed. The error
message might be as follows :-

           ^Syntax :- SEArch <string/num> <start> [end]^

   Items in ^angled brackets^ are obligatory, items in ^square brackets^ are
optional. In the above example, you must give the start address - ^<start>^
- but may omit the end address - ^[end]^.

   Some commands require an option to be specified, e.g ^(HELP -S)^. The
option is preceded by a ^ - ^. In the above example, the ^ -S ^ option gives
information about system (QDOS) variables.

   You can cancel a partially entered line by pressing ESCape.
~^Disassembly and Memory Dump^

   While performing a disassembly or dump, the function key ^ F1 ^ will
freeze and unfreeze the screen. When the screen is frozen, the
disassembly or dump can be continued a line at a time by pressing the
^SPACE BAR^.

   The monitor is able to accept commands at any time. It is therefore
not necessary to complete a disassembly or dump before typing in the next
command.

^Disassembly^

   Syntax :- ^DASm <start> [end]^

   This command performs a disassembly of the memory area specified
between ^<start>^ and ^[end]^. The end address is optional. If it is
omitted, the disassembly will continue until the user inputs another
command.

   The disassembled line consists of the address and opcodes of the
instruction together with an ASCII dump. Non-ASCII characters are printed
as a ^ . ^.

   All illegal instructions, illegal addressing modes and sizes cause the
output ^ILLEGAL INSTRUCTION^. This, together with the ASCII dump, allows
the user to distinguish between program and data areas more easily.
Alternately, giving an ^ILLegal OFF^ command will cause a ^dc.w $xxxx^ to be
output instead.

^Memory Dump^

   Syntax :- ^DUMp <start> [end]^

   This performs a hex & ASCII dump of the specified memory area. The end
address is optional.
~^Dual Windows^

   Dual windows can be set up by pressing ^CTRL D^ for the disassembler
window and ^CTRL H^ for the hex dump window.

   A dual window provides a second area in which to disassemble or hex
dump subroutines encountered during the disassembly of a main program.

   After disassembly of the subroutine is complete, press ^CTRL D ^ again,
then ^SPACE^ or ^ F1 ^ to resume the original disassembly. The window with
the ^GREEN^ border is the one currently being used. ^ F4 ^ will reset all
windows.
~^Program Execution^

^Trace^

   Syntax :- ^TRAce [-r] [start]^

   The trace command allows the user to single step through a program.
After each instruction has been obeyed, the next instruction is
disassembled and printed. The register dump is updated and a predefined
area of memory (see ^DISplay^) may also be displayed.

   Any register which has been changed by the executed instruction is
highlighted.

   Hitting ^SPACE^ causes the next instruction to be executed. Automatic
repeated tracing is started by pressing ^ F1 ^. It is stopped by pressing
^ F1 ^ again.

^With the -r Option^

   By default the trace command sets register values to zero. If you wish
to obey a section of code with known register values you must first
initialise the registers, and use the trace ^ -r ^ option.

   e.g. ^TRAce -r <address>^.

^TRAce without parameters^

   Commands can be invoked while a trace is taking place. These commands
do not interfere with the operation of the trace. Instead of typing ^SPACE^
you may enter an extended command. When the command has been obeyed,
press ^SPACE^ to resume tracing the program. However, if the extended
command is a disassembly or a dump, pressing ^SPACE^ continues that
operation. In such cases, type ^TRAce^ to resume tracing of the program.
All registers will remain unchanged.

^Exit from TRAce^

   There is no need to terminate the ^TRAce^ command as you are not
prevented from using other commands. To start tracing a new program,
type ^TRAce <start of new prog.>^. This will reset all the stack pointers.
A relevant RTS will terminate the ^TRAce^ command.
~^Altering of registers^

   Syntax :- ^REGister^

   Registers can be altered by using the above command while a program is
being traced. Each register value from D0 to A6 will be presented along
with its current value. Type in the new value for the register. If you do
not wish to alter a particular register, press ^ENTER^. Type ^ / ^
followed by ^ENTER^ if you wish to restart from D0.
~^SETrace ON and OFF^

   Syntax :- ^SETrace ON/OFF <address>^

   Sometimes, only parts of a program need to be traced through. For this
reason, it is possible to turn the trace ^ON^ and ^OFF^ at different
sections of the program. These are referred to as 'trace points'.

   Up to twenty trace points can be placed in ROM or RAM areas. By
default, tracing is enabled at the start of a program.

   If ^SSS^ is the start address and ^EEE^ the end address of a bug-free
routine, ^SETrace OFF SSS^ followed by ^SETrace ON EEE^ will disable
tracing of this part of the program.

   ^SETrace^ without parameters will delete all trace points.

   If the user places a ^SETrace OFF^ at a wrong address and only notices
it while the program is running, he can regain control of the program
flow by pressing ^ESC^. The trace is turned ON and the user can continue
his debugging session.

^Tracing through QDOS traps^

   Syntax :- ^QTRap ON/OFF^

   It is not usual to trace through QDOS. However, a special command is
included for those who wish to probe QDOS routines. This command is valid
only when a program is being traced.

   When enabled, all instructions in supervisor mode are single-stepped.
This feature is disabled with the OFF option (default).

   It must be noted that certain QDOS routines, e.g the formatting of a
microdrive cartridge, must be executed in real-time. Although it is
possible to trace these routines, satisfactory results cannot be
guaranteed.
~^Without Trace^

   Programs can be executed without tracing by using either of the
following commands :-

   1. ^CALl [-r] <address>^
   2. ^EXEc [-r] [address]^

   Programs executed this way must end with ^RTS^ or by being explicitly
'killed' ^(using MT_FRJOB)^. Programs can also be interrupted and resumed
after a ^BREAK^ or after pressing ^ESC^. More about these later.

   If the ^ -r ^ option is included, the user can set the registers prior
to execution. Without this option, registers are undefined at the start
of execution.

^CALl^

   This command enables subroutines to be tested.  The subroutines must
contain an RTS. The subroutine is executed as if it were part of the
monitor. Therefore, if the subroutine issues a QDOS MT_FRJOB with D1=-1,
it is the monitor that is killed !

^EXEc^

   If no address is specified in the command, the job is started at its
base address. This is the most commonly used form. Alternatively, a start
address for the job can be given. This is useful when running programs in
the heap area.

   The ^EXEc^ command sets up a separate job with the monitor as its
'parent'.  Jobs must be explicitly killed.

   However, since the beginner to QDOS tends to end a job with RTS, the
monitor has been designed to guard against this happening. If a job ends
with RTS, a warning is given and the job is inactivated. The monitor will
^NOT^ crash.
~^Break Points^

   Syntax :- ^BREak [address]^

   A break is achieved by replacing the current instruction with a Trap
#5. For this reason, break points can only be placed in RAM areas. To
debug programs which are not in RAM areas, use the ^TRAce^ command and
^SETrace OFF^ at the start of the program. ^SETrace ON^ will then act like
a break point.

   Without parameters, the ^BREak^ command deletes all breaks. To delete
an individual break point, use ^BDElete^. A maximum of twenty break points
is available at any time. The user must remove break points after a new
program is loaded.

   The monitor will refuse to insert breaks at odd addresses. Make sure
that break points are inserted at the beginning of an instruction.

   When a break point is encountered, the program is interrupted but can
be resumed with all registers unchanged.

   On detecting a break the monitor enters break-processing mode. The
following options are available :-

   Press ^ C ^      Continue execution with registers unchanged.
         ^ J ^      Unconditional jump to a given address.
         ^ R ^      Alter registers.
         ^ SPACE ^  Single step through next instruction.
         ^ ENTER ^  Go to command level
         ^ ESC   ^  Quit/end execution.

   Pressing ^SPACE^ will execute the next instruction and display all the
registers - rather like ^TRAce^.

   The ability to start single stepping at a break point allows the user
to reach a suspect part of a program very quickly and then single step
through it.

   Pressing ^ENTER^ gives access to many of the extended commands. Notable
exceptions are ^TRAce^, ^EXEc^, ^CALl^, ^LJOb^ - some of these commands
could cause recursion and eventually a stack overflow. The command prompt
is changed to ^Brk>^ to remind the user that a break point has been
reached.  Pressing ^ENTER^ by itself in reply to this prompt returns to
break-processing mode.

   During break-processing mode, the ^ = ^ symbol is equivalent to typing
the address of the break.

   Break points will not appear as 'trap #5' in a disassembly. The
command ^LISt^ lists all break and trace points.

^To delete break points^

   Syntax :- ^Bdelete^

   To delete a particular break point use Bdelete.
   Note : to delete all break points, type ^BREak^ with no parameters.
~^Interrupting Machine Code Programs^

   In most cases, programs can be interrupted by pressing the ^ESCape^
key. This is useful when the program being debugged loops. Programs in
supervisor mode are not interrupted until they enter user mode.
Similarly, if interrupts are disabled, your program can not be
interrupted.

   When interrupted, the monitor behaves as though a BREAK instruction
has been encountered.

   However, if a program goes wrong ^and^ corrupts the monitor or any
system variables, ESC is not guaranteed to regain control. If this
happens, reset the QL and re-load the programs.

   Note that an interrupt can only occur if the monitor's input channel
is currently selected. Thus the user can use ^ESC^ in their own program.

   Under the pointer enviroment a job which opens a  scr or con channel
will prevent the monitor from being able to ^ESC^ the job.
~^Load, Save and Device^

^LOAD^

^At a specific address^

   Syntax :- ^LBYtes <filename> <address>^

   This is equivalent to SUPERBASIC's LBYTES and causes a file to be
loaded at the address specified. It is the user's responsibility to
ensure that the load area is available.

^Programs and Data files^

   Syntax :- ^LJOb <filename>^

  This command is used to load and set up a job. The job is loaded in the
Transient Program Area and is put in suspension. Only one job can be
loaded at a time. Start it with ^EXEc^.

   Syntax :- ^LOAd <filename>^

  Other programs and data files can be loaded in the heap area using this
command. If the load completed successfully, the start address is
printed.

   This address is required if the program is removed. The function keys
^SHIFT F1-F5^ can be defined to contain these addresses. To remove files
loaded in this way, the command ^REMheap <address>^ should be used.

^SAVEs^

   Syntax :- ^SEXec <name> <start> <end> [data space]^
             ^SBYtes <name> <start> <end>^

   If the ^<end>^ address is preceded by a ^ + ^ sign, the address is taken
as being the number of bytes to be saved. For example, with +8 the end
address is equivalent to <start+8>.

   Using ^SEXec^, the file is saved in a form which is suitable for later
execution by SUPERBASIC's EXEC or EXEC_W. The ^[data space]^ parameter can
be omitted. Its default value is 4096 bytes.

   The command ^SBYtes^ is equivalent to SUPERBASIC's SBYTES and a data
file is created.

   If a file with the same name as the one specified already exists, a
message is printed and the user is given the option of overwriting it.

^Default device^

   Syntax :- ^DEVice <pathname> [help pathname]^

   Sets the default pathname for all file operations. If the help pathname
is not given then it uses <pathname>.

^Delete^

   Syntax :- ^DELete <name>^

   For the sake of completeness, a delete file command is also included.
This command is the equivalent of SUPERBASIC's DELETE.
~^HELPs^

   Syntax :- ^HELp [-sbjwc] [drive]^

   The ^HELp^ command produces this display and gives information about
various aspect of QDOS. The last parameter can be omitted if the monitor
help files (inf_) are on the default drive (see ^DEVice^), otherwise you
must specify the drive.

   With no options, ^HELp^ produces information about the use of this
monitor. Use ^  ^ and ^  ^ to move to the previous and next page respect-
ively.  ^ F5 ^ displays the index and allows the user to select a page.
Press ^ ESC ^ to abort and any other key to unfreeze the display.

   With ^ -s ^, the values (and definitions) of all the system variables
are printed. Similarly, with ^ -b ^, the pointers to BASIC variable lists
and stacks are printed.

   The ^ -j ^ option prints all the variables and their definitions in
the Job Control Block. The definitions of all jobs, whether active,
suspended or inactivated, are given in turn. Pressing ^ENTER^ at any time
aborts the printing of the current definitions and moves on to the next
set of job definitions. By pressing ^ESC^, the user can return to the
command line.

   The ^ -c ^ option prints all the variables from the channel definition
blocks while ^ -w ^ prints all those in the window definition blocks (if
the PE is present then this will be the extended window definition).

By knowing the address of these definitions, the user can have direct
access to parameters such as character increments.
~^Printers and other devices^

   Four commands are provided to link two of the monitor's windows to
output devices. These may be any valid QL peripheral.

^Opening of a channel^

   Syntax :- ^OPEn <name> <device>^

   Before output can be sent to a device, a channel must be opened. This
can be done using the above command. A ^name^ can be up to eight
characters. A maximum of two channels may be open at any time.
~^Linking a channel to a window^

   Syntax :- ^LINk [-dhn] <name>^

   The newly opened channel can then linked to a window with this
command. The ^ -d ^ option links the device to the ^"disassembly"^
window while the ^ -h ^ option links it to the ^"hex dump"^ window.

   Option ^[-dn]^ only applies to the ^ D ^ window. Using this option, a
listing is printed. With the help of the assembler and editor, the user
can modify and re-assemble routines without requiring access to source
codes.

   A channel can be linked to both windows by issuing two LINk commands;
LINk -h <name> then LINk -d <name> (or -dn). After linking, any character
printed in the relevant window is also sent to the device. LINk <name>
ie, without any -option, defaults to LINk -d <name>.
~^Unlink a channel^

   Syntax :- ^UNLink [-dh] [name]^

   When printing is complete you may unlink the device from the window
with this command. Without parameters, all devices are unlinked. The
^ -dh ^ options are the same as for ^LINk^.

   Without any options, e.g ^UNLink [name]^, the device is unlinked from
both windows. A device can be unlinked from the ^ D ^ window but remain
linked to the ^ H ^ window, or vice-versa. Note that ^UNLink^ does not
close the opened channel. It can therefore be linked again at a later
stage without re-opening.
~^Close channel^

   Syntax :- ^CLOse [name]^

   Closing of an open channel can be achieved by the ^CLOse^ command.
Without parameters,the command closes all opened channels.

^Example^

   If we want to send information to the printer, we might execute the
following commands :

        ^OPEn^ printer ser1
        ^LINk^ -d printer
        Disassemble        -----  sent to printer
        Hex Dump           -----  not sent to printer
        ^UNLink^ -d printer
        any commands              not sent to printer
        ^LINk^ -h printer
        Dump               -----  Hex dump sent to printer
        Disassemble        -----  Not sent to printer
        ^CLOse^ printer
~^User-defined function keys^

   Syntax :- ^DEFine <1-5> <expression>^

   The function keys, ^SHIFT F1-F5^ (ie, F6-F10), can be user-defined with
this command. ^SHIFT F1^ is referred to as key ^ 1 ^ and ^SHIFT F5^ as key ^ 5 ^.

   The ^<expression>^ does not have to be a string and a newline can be
included using ^  ^. For example, ^DEFine 1 LOAd flp1_xxx ^ defines
^SHIFT F1^ so that file flp1_xxx is loaded every time it is pressed.

   The keys can be used to store the address at which a file is loaded.
To execute the program, just type ^CALl ^ on the command line and press
the defined key. To disassemble the program, type ^DASM ^ and press
the defined key. Note that this is not necessary for programs loaded as
jobs, as preceding the address by a ^ ` ^ makes the address relative to the
start of the job(= `0).

You can use the * (ie, last value returned) in a DEFine string, it will
be replaced by the actual value. If you wish to insert a real * in the
string then use **. You can also have the cursor positioned automatically
in a DEFine string when it is recalled, just put a @  character at the
desired position in the string.

For example;

HEAp 100           (say returns 1ABC0)

DEF 1 sbytes flp1_@_bin * **

will cause SHIFT F1 to reproduce the following string;

sbytes flp1_bin 1ABC0 *

If used after an assembly the * will represent the last address of the
code with the cursor (ie, the ) ready to input a filename by being
between the two underscore characters.
~^Dual Screens^

   This facilty is not available if the pointer enviroment is resident,
if you try to use it you will get 'not implemented' returned. Thus this
facility can only be used on machines with standard QL screen memory.

   Syntax :- ^DSCreen [-s]^
             ^SSCreen^

  The main use of dual screens is to assist in debugging programs -
especially graphics programs. You can switch between your program display
screen and the monitor screen by pressing ^CTRL S^.

   When set up, the monitor's output is sent to one screen while output
from the user's program is sent to the other. The correct screen to be
displayed at any time is automatically selected by the monitor. It works
by directly swapping the memory contents of the current screen (screen 0
or 1 for Minerva users) between the user code/job display and the
monitor's display (ie, not by switching the QL hardware screen 0/1).

   The command ^DSCr^ sets up the second screen (subject to memory being
available). With the ^ -s ^ option, the second screen is temporarily
disabled. This is useful when tracing through part of a program where the
screen is not actually altered.

   ^SSCr^ reverts to single screen mode and releases all the memory used
for the second screen. That screen is thus completely lost. If you wish
to keep the screen, use ^DSCr -s^ instead.

   If the monitor job is being used in Minerva's second screen then
DSCreen will use the second screen also. Be aware that if you issue an
(extended) MODE command before you open new window channels you may not
get the result you expect since  the new channels may have been opened
in the 'other' screen! (see Minerva guide page BAS.2 and .3)
~^Window^

   Syntax :- ^WINdow D/H ^.

   This command allows the user to have a larger disassembler or hex
dump window. It is particularly useful when the register dump window is
not being used or when the monitor is being used as a disassembler only.

   ^NOTE^ :- Windows can be reset by pressing ^ F4 ^.
~^Search and Insert^

^Search^

   Syntax :- ^SEArch <string/num> <start> [end]^

   This command searchs for the occurrence of a string of characters or a
sequence of numbers between the start and end addresses. The end address
is optional as the user can interrupt the search at any time by pressing
^ESC^.

   If the search is successful, the address at which the string was found
is printed and a memory dump starting from that address is output. The
user then has the choice of either continuing the search or ending it.

   The search is a fast character by character search and lower and upper
case letters are fully distinguished.

   A ^<string>^ is defined as an expression between quotes, e.g 'string'.
A ^<num>^ is defined as a sequence of hex digits, e.g 1234. As a further
example :- the ^<string>^ '1234' is equivalent to the ^<num>^ 31323334.

   Be aware that searching (ie, reading) any memory locations in which
hardware control registers are situated can cause unpredictable behaviour
from the devices they control.

^Insert^

   Syntax :- ^INSert <string/num> <address>^

   ^Insert^ inserts a string of characters or a sequence of numbers at the
specified address. ^<string/num>^ has the same definition as in ^SEArch^.
~^Move and Fill^

^Move^

   Syntax :- ^MOVe <start> <end> <address>^

   This command shifts a block of memory between the <start> and <end>
addresses to a specified <address>. The original block remains unchanged
unless the new block overlaps with it.

   The system might crash if a lump of memory is moved over the system
variables or the monitor's area. It is the user's responsibility to
ensure that the movement of any block of memory does not crash the
system.

^Fill^

   Syntax :- ^FILl <string/num> <start> <end>^

   ^FILl^ inserts the <string/num> at the <start> address and repeats
itself until the <end> address is reached.
~^Heap^

   Syntax :- ^HEAp <number of bytes>^

   This command deals with the allocation and release of memory in the
HEAP area.

   ^HEAp <number of bytes>^ is used to allocate memory. If this is
successful, the base address of the allocated area is printed. A note of
the address must be made if the area is to be released at a later stage.
(See below)

   Syntax :- ^REMheap <address>^

   This command releases an area of the heap which was previously
allocated using ^HEAp^. It can also be used to remove programs loaded with
the ^LOAd <name>^ command. Note, the heap header is checked for the
monitor's job ID first, since giving a wrong address can cause a crash.
~^Edit Memory^

   Syntax :- ^EDIt <address>^

   This command provides a small but very useful full 'window' memory
editor. The various arrow keys     can be used to move the cursor
around the window. Scrolling is automatically performed when the top or
bottom of the window is reached. CTRL  can be used to delete the first
nibble of a hex number entered. After the second nibble is entered, the
cursor moves to the next location. In order to alter a number entered,
use  and type the correct number.

   If ^ F3 ^ is pressed, then the ASCII code of any character can be
entered directly by pressing the corresponding key. The editor stays
in this mode until ^ F3 ^ is pressed again. Hexadecimal numbers can be
entered one nibble at a time as described above. ^ F3 ^ allows the user to
alternate between the two modes.

   A 'beep' sound is made if the key pressed is not valid or is outside
the hex range of numbers. Both nibbles must then be typed in. To exit the
editor, press ^ESCape^ or ^ENTER^.
~^Set start of memory display^

   Syntax :- ^DISplay <address>^

   After each break or after each instruction during a trace, a
pre-defined area of memory can be displayed. This allows the user to keep
an eye on certain variables. ^ F2 ^ can be used to enable or disable the
display alternately. The display is very expensive on processor overheads
and will slow down the single stepping of a program. It should,
therefore, be enabled only when required and disabled when not needed.

   This command sets the start of the section of memory displayed. The
end address is determined by the size of the Hex dump window at the time
of display and therefore need not be specified.
~^Job Control/Display commands^

     To load a job see the ^Load, Save and Device^ page.

    ^JOBs^
       lists all current jobs.

    ^RJOb <job> <tag>^
       releases a job.

    ^KJOb <job> <tag>^
       kills a job.

    ^SJOb <job> <tag> <timeout>^
       suspends a job. If timeout=-1, the job is suspended indefinitely.
     No other negative timeout should be used.

    ^PJOb <job> <tag> <priority>^
       alters the priority of a job. The priority can have any value
     between 0 and 127. The job will be inactivated if the priority=0.
~^Commands from files^

   Syntax :- ^FCOm <name>^

   The monitor can also accept commands from a file instead of the
keyboard. This can be done by specifying the input file to the ^FCOm^
command. You can also pass an FCOm filename in the command string when
starting the monitor job. ie, EX flp1_monitor;flp1_setup

^Arithmetic Operations^

   Simple operations such as addition, subtraction and base conversions
are included to spare the programmer the need to look for a calculator at
the most inconvenient times.

   ^+ <num> <num>^ will add two numbers and print the result in hex. Note
that the numbers can be in hex or decimal. For example, ^+ ff &10^ is
acceptable.

   ^- <num1> <num2>^ subtracts ^<num2>^ from ^<num1>^.
   ^DEC <num>^ converts from hexadecimal to decimal.
   ^HEX <num>^ converts from decimal to hexadecimal.
   ^BIN <num>^ converts from decimal or hexdecimal to binary.
   ^BHEx <binary num>^ converts from binary to hexadecimal.
   ^NEG <num>^ negates a number and prints the result in hexdecimal.
~^Miscellaneous commands^

   Syntax :- ^VERsion^
   This  prints the version of QDOS or SMSQ and the base address of the
system variables.

   Syntax :- ^TABle^
   This prints the address of the vector table as used by the monitor.
Any re-direction of vectors will have to use this table.

   Syntax :- ^LISt^
   This lists all the trace and break points.

   Syntax :- ^MONitor [0-9]^
   Appends the number given to the monitor's jobname and all its prompts.
If used, this can help differentiate between multiple jobs. If no number
is given then the default of no appendage is assumed.

   Syntax :- ^ILLegal [ON/OFF]^
   Normally if the disassembler comes across an instruction word it
doesn't understand it prints 'ILLEGAL INSTRUCTION' in the disassembly. 
If you prefer dc.w statements instead then use ILLegal OFF, the default
is ON. ILLegal without a parameter means OFF.

   Syntax :- ^QUIt^
   Used to exit the monitor. All channels opened are closed, any loaded
job is killed and any heap area allocated is automatically released.

   Syntax :- ^BEEp [ON/OFF]^
   The default is ON. BEEp without a parameter means OFF (quiet mode).
~^Assembler^

   Syntax :- ^ASM [address] [drive]^

   The monitor has a built-in one-line/two-pass assembler which can
assemble instructions taken from either the keyboard or a file.

   All 68000 instructions can be assembled using standard MOTOROLA mne-
monics. A number of directives are provided.

   The assembler automatically selects the most appropriate variation of
an instruction, e.g ^add.l #8,a0^ will be coded as ^addq.l #8,a0^. It also
automatically moves the location counter to a word boundary if necessary.

   Typing ^ENTER^ as the first character allows the user to exit the
assembler temporarily. To re enter the assembler, type ^ASM^ with or
without ^[address]^ as parameter. With no address specified the assembler
continues from where you left off.

   Numbers are by default decimal unless preceded by a
        ^ $ ^ for hexadecimal numbers
        ^ % ^ for binary numbers

   Characters/strings can be represented by enclosing them between
quotes, e.g ^ 'a' ^ or ^ "ab" ^.

   Most of QDOS traps and vectors, e.g MT_FRJOB, IO_OPEN or UT_ERR, are
^pre-defined^ and can be used directly, (see ^QDOS labels^).

   A typical example of how this command is used :-
        ^ASM 40000^
        ^Out flp2_output^    Output to a file (if required)
        ^move.l a0,d0^       As line assembler
        ^In flp2_input^      or as two-pass assembler
~^Loading the assembler^

  The assembler is not loaded along with the monitor. It is automatically
loaded when the ^ASM^ command is used for the first time. Once loaded, the
assembler becomes an integral part of the monitor.

   For the ^first^ use of the ^ASM^ command, the ^[drive]^ parameter has to
be included only if the assembler file is not on the default device.
Subsequent use of the command does not require the ^[drive]^ parameter.
~^Input from keyboard^

   In this mode, the assembler is particularly useful for assembling
short programs and for altering programs already in memory.

   When the assembler encounters an undefined symbol, the line is
assembled with an arbitrary number assigned to the symbol. The error
message, ^Undefined Symbol^, is also printed in case the symbol has been
mistyped. It can otherwise be ignored.

   This allows the user to use forward references, which are particularly
useful if the exact address of a jump is not known when the line is
entered.

             e.g  ^jmp    xxx^
                  ^nop^
                  ^.xxx   rts^

   Note that if a symbol has been mistyped and was not intended as a
forward reference, the line is still assembled. In this case, readjust
the location counter by using an ^ORG^ directive.

   The ^END^ directive must be used before exiting the assembler. All
forward references are resolved. Error messages are printed if any errors
occur. The user can choose to ignore these by typing ^NEW^ followed by
^END^.

^Input from file^

   The assembler can also assemble programs from files. The ^INCLUDE^
directive can be used to specify the file.

   e.g  ^INCLUDE^ flp2_file
~^Labels^

   Labels have to be preceded by either a ^ . ^ or a ^ / ^. Previously
undefined labels can be preceded by the ^dot^ while ^ / ^ can be used to
redefine the value of a given label. ^ / ^ is particularly useful for
temporary labels(e.g labels for loops).

   e.g ^.label equ $05^
       ^/loop  equ *^ to change the value of the previously defined ^loop^

   File input is treated in a different manner. This is to maintain
compatibility with other assemblers. When input is being taken from a
file the first word is taken to be a label and instructions have to be
preceded by a ^SPACE^.

   e.g ^label  moveq   #0,d0 ^
       ^       moveq   #1,d1 ^

   See also under ^QDOS labels^ for inbuilt definitions.
~^Directives^

   These are instructions to the assembler which do not generate any
code - with the exception of ^ DC ^.

^ORG <address>^
   This alters the location counter. It is used mostly by the line
assembler.

^INCLUDE <file>^
   This directive can be abbreviated to ^ IN ^ and causes the assembler
to assemble the specified file. It can be used within a file causing the
named file to be read as if it were present in the original source file.
^INCLUDE^ may be nested to three levels.

^OUT <file>^
   Causes all binary output to be sent to the specified file. In this
case the address given in the ^ASM^ command is irrelevant but it must be
specified. For example use ^ ASM 0 ^.

   This directive will return ^Not Complete^ if there are any undefined
symbols. Type ^NEW^ followed by the ^OUT^ directive.

^DATA <number>^
   Sets the size of the data space to be allocated by QDOS when the
program is executed.

   The default size is 4096 bytes and is irrelevant when output is not
to a file.

^LIB <file>^
   Allows a previously assembled machine code program to be included.
The binary file may contain useful library subroutines or any other code.

   It is used together with the symbol file. This file allows the
assembler to refer to labels within the binary file. It can be produced
with the ^SYM^ directive (See below).

   e.g  sym1    equ  *
        sym2    equ  *+4
        lib     flp2_sym

^SYM <file>^
   Produces a symbol file which may be included with a library file.

   e.g ^rel_sym   equ    *+OFFSET^  for a relocatable symbol.
       ^abs_sym   equ    VALUE   ^  for an absolute symbol.

^EQU^
   ^label  EQU  <expr>^
   Assigns the value of ^<expr>^ to ^label^. ^<expr>^ may only refer to
defined symbols.

^DS.[bwl] <number>^
   Reserves memory storage. The number cannot refer to an undefined
symbol.
        e.g  .store ds.l 4

^DC.[bwl] <expr>{,<expr>}^
   Defines constants.

   ^<expr>^ can be either a string or a number. In the case of strings,
^DC.L 'a'^ causes the character to be left justified whereas ^DC.L 'a'+0 ^
causes it to be right justified.

^LIST <device>^
   This produces a listing including the address for each instruction.

^ERRORS <device>^
   Similar to ^LIST^ but will include only instructions containing errors.

^NEW^
   Deletes all defined symbols and resets the assembler's original para-
meters. It is mostly used after an assembly is aborted for any reason.

^END^
   Resolves all forward references and releases all memory space.
It also produces a symbol table if ^SYM^ has been previously specified
and closes all opened files. It is the usual way to conclude an assembly.

   ^END^ returns ^Not Complete^ if any errors have occurred while forward
references are resolved. In some cases these errors can be edited, but
the user must ensure that the new instruction produces a code of the same
length. e.g ^bra.s address^ cannot be replaced by ^bra address^.

   If you wish to ignore the errors type ^NEW^ followed by ^END^.
~^ERRORS^
   The assembler generates three types of errors :-

   (1) QDOS errors, e.g I/O errors, 'Out of Memory'. These are generally
fatal and cause the current assembly to end.

   (2) Instruction errors during the first pass. In this case the assem-
bler generates an error message and the user has the following options :-

    Press  ^ E ^     To edit/type in new instruction
           ^ESC^     Abort assembly
           ^ANY KEY^ Ignore error

   (3) Forward references during the second pass. The same options as (2)
are available, but care must be taken if the instruction is corrected.
The code of the new instruction must be of the ^SAME LENGTH^ as the old
one. Note that if a ^short branch (bra.s)^ which returns ^Out of range^ is
replaced by a ^long branch (bra)^ the code length will change. If in
doubt, re-edit and re-assemble the file.

   If ^END^ returns 'Not Complete' and if you wish to ignore the remain-
ing errors, e.g mistyped symbols, type ^NEW^ followed by ^END^.

^Arithmetic operators^

  The only operators available are ^ + ^ and ^ - ^.
~^QDOS labels^

The following labels are automatically recognised by the assembler;

TRAP #1           TRAP #3           VECTORS             ERROR CODES

MT_INF     00     IO_PEND    00     MM_ALCHP   00C0     ERR_NC     FF
MT_CJOB    01     IO_FBYTE   01     MM_RECHP   00C2     ERR_NJ     FE
MT_JINF    02     IO_FLINE   02     UT_WINDW   00C4     ERR_OM     FD
MT_RJOB    04     IO_FSTRG   03     UT_CON     00C6     ERR_OR     FC
MT_FRJOB   05     IO_EDLIN   04     UT_SCR     00C8     ERR_BO     FB
MT_FREE    06     IO_SBYTE   05     UT_ERR0    00CA     ERR_NO     FA
MT_TRAPV   07     IO_SSTRG   07     UT_ERR     00CC     ERR_NF     F9
MT_SUSJB   08     SD_EXTOP   09     UT_MINT    00CE     ERR_EX     F8
MT_RELJB   09     SD_PXENQ   0A     UT_MTEXT   00D0     ERR_IU     F7
MT_ACTIV   0A     SD_CHENQ   0B     UT_LINK    00D2     ERR_EF     F6
MT_PRIOR   0B     SD_BORDR   0C     UT_UNLNK   00D4     ERR_DF     F5
MT_ALLOC   0C     SD_WDEF    0D     MM_ALLOC   00D8     ERR_BN     F4
MT_LNKFR   0D     SD_CURE    0E     MM_LNKFR   00DA     ERR_TE     F3
MT_ALRES   0E     SD_CURS    0F     IO_QSET    00DC     ERR_FF     F2
MT_RERES   0F     SD_POS     10     IO_QTEST   00DE     ERR_BP     F1
MT_DMODE   10     SD_TAB     11     IO_QIN     00E0     ERR_FE     F0
MT_IPCOM   11     SD_NL      12     IO_QOUT    00E2     ERR_XP     EF
MT_BAUD    12     SD_PCOL    13     IO_QEOF    00E4     ERR_OV     EE
MT_RCLCK   13     SD_NCOL    14     UT_CSTR    00E6     ERR_NI     ED
MT_SCLCK   14     SD_PROW    15     IO_SERQ    00E8     ERR_RO     EC
MT_ACLCK   15     SD_NROW    16     IO_SERIO   00EA     ERR_BL     EB
MT_ALBAS   16     SD_PIXP    17     CN_DATE    00EC
MT_REBAS   17     SD_SCROL   18     CN_DAY     00EE
MT_ALCHP   18     SD_SCRTP   19     CN_FTOD    00F0
MT_RECHP   19     SD_SCRBT   1A     CN_ITOD    00F2
MT_LXINT   1A     SD_PAN     1B     CN_ITOBB   00F4
MT_RXINT   1B     SD_PANLN   1E     CN_ITOBW   00F6
MT_LPOLL   1C     SD_PANRT   1F     CN_ITOBL   00F8
MT_RPOLL   1D     SD_CLEAR   20     CN_ITOHB   00FA
MT_LSCHD   1E     SD_CLRTP   21     CN_ITOHW   00FC
MT_RSCHD   1F     SD_CLRBT   22     CN_ITOHL   00FE
MT_LIOD    20     SD_CLRLN   23     CN_DTOF    0100
MT_RIOD    21     SD_CLRRT   24     CN_DTOI    0102
MT_LDD     22     SD_FONT    25     CN_BTOIB   0104
MT_RDD     23     SD_RECOL   26     CN_BTOIW   0106
                  SD_SETPA   27     CN_BTOIL   0108
                  SD_SETST   28     CN_HTOIB   010A
TRAP #2           SD_SETIN   29     CN_HTOIW   010C
                  SD_SETFL   2A     CN_HTOIL   010E
IO_OPEN    01     SD_SETUL   2B     BP_INIT    0110
IO_CLOSE   02     SD_SETMD   2C     CA_GTINT   0112
IO_FORMT   03     SD_SETSZ   2D     CA_GTFP    0114
IO_DELET   04     SD_FILL    2E     CA_GTSTR   0116
                  SD_POINT   30     CA_GTLIN   0118
                  SD_LINE    31     BV_CHRIX   011A
                  SD_ARC     32     RI_EXEC    011C
                  SD_ELIPS   33     RI_EXECB   011E
                  SD_SCALE   34     BP_LET     0120
                  SD_FLOOD   35     IO_NAME    0122
                  SD_GCUR    36
                  FS_CHECK   40
                  FS_FLUSH   41
                  FS_POSAB   42
                  FS_POSRE   43
                  FS_MDINF   45
                  FS_HEADS   46
                  FS_HEADR   47
                  FS_LOAD    48
                  FS_SAVE    49
~
